## net.sf.saxon.functions
Class DistinctValues

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.expr.FunctionCall
              net.sf.saxon.functions.SystemFunction
                  net.sf.saxon.functions.CollatingFunction
                      net.sf.saxon.functions.DistinctValues

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

public class DistinctValues
extends CollatingFunction

The XPath 2.0 distinct-values() function

See Also:
  Serialized Form

Nested Class Summary
`static class` `DistinctValues.DistinctIterator` Iterator class to return the distinct values in a sequence

Field Summary

Fields inherited from class net.sf.saxon.functions.CollatingFunction
`conversionContext`

Fields inherited from class net.sf.saxon.functions.SystemFunction
`operation`

Fields inherited from class net.sf.saxon.expr.FunctionCall
`argument`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`DistinctValues()`

Method Summary
`protected AtomicSortComparer` `getAtomicSortComparer(int arg, XPathContext context)` Get a AtomicSortComparer that can be used to compare values
`SequenceIterator` `iterate(XPathContext context)` Evaluate the function to return an iteration of selected values or nodes.

Methods inherited from class net.sf.saxon.functions.CollatingFunction
`checkArguments, getAtomicComparer, getCollator, preEvaluate`

Methods inherited from class net.sf.saxon.functions.SystemFunction
`addContextDocumentArgument, computeCardinality, computeSpecialProperties, display, getDetails, getErrorCodeForTypeErrors, getItemType, getRequiredType, main, makeSystemFunction, setDetails, useContextItemAsDefault`

Methods inherited from class net.sf.saxon.expr.FunctionCall
`checkArgumentCount, getDisplayName, getFunctionNameCode, getNumberOfArguments, iterateSubExpressions, optimize, promote, setArguments, setFunctionNameCode, simplify, simplifyArguments, typeCheck`

Methods inherited from class net.sf.saxon.expr.ComputedExpression

`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getColumnNumber, getConstructType, getDependencies, getExecutable, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, suppressValidation, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DistinctValues

    public DistinctValues()

Method Detail

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Evaluate the function to return an iteration of selected values or nodes.

  Specified by:
    `iterate` in interface `Expression`
  Overrides:
    `iterate` in class `ComputedExpression`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### getAtomicSortComparer

    protected AtomicSortComparer getAtomicSortComparer(int arg,
                                                       XPathContext context)
                                                throws XPathException

  Get a AtomicSortComparer that can be used to compare values

  Parameters:
    `arg` - the position of the argument (starting at 0) containing the collation name. If this argument was not supplied, the default collation is used
    `context` - The dynamic evaluation context.
  Throws:
    `XPathException`